precision highp float;

// Attributes
attribute vec3 position;

// Uniforms
uniform mat4 world;
uniform mat4 worldViewProjection;
uniform float invertY;
uniform float invertZ;

// Outputs
varying vec3 v_position; // World space position that will be used to sample the cubemap

void main() 
{
	gl_Position = worldViewProjection * vec4(position, 1.0);
    
	vec4 worldPos = world * vec4(position, 1.0);
	/// Final worldspace position assignment, however, due to how Babylon handles rendering...
	/// it is necessary to sometimes to invert the Y or Z of the position to maintain proper alignment
	v_position = vec3(worldPos.x, worldPos.y * invertY, worldPos.z * invertZ);
}
